use strict;
use warnings;

my ($in_contigs_tsv, $out_contigs_assigned) = @ARGV;

open (my $in, "<", $in_contigs_tsv) or die "could not open $in_contigs_tsv for reading\n";
open (my $out, ">", $out_contigs_assigned) or die "could not open $out_contigs_assigned for writing\n";
print $out "DOMAIN\tSUPERGROUP\tNUM_PREDS\n";
my $line = <$in>;
$line = <$in>; # remove header
while (defined $line)
{
	chomp ($line);
	#CONTIG	BEST_HEADER	BITSCORE_BEST_MATCH	EVALUE_BEST_MATCH	SOURCE	TAX_ACC	SEQID_TO_TAX	TAX_LEVEL	LINEAGE_INFO	NUM_PREDS
	my ($contig, $header, $bitscore, $evalue, $source, $tax_acc, $seqid_to_tax, $tax_level, $linage_info, $num_preds) = split(/\t/, $line);
	
	my $linage_info_lc = lc($linage_info);
	$linage_info_lc =~ s/\s+/_/g;
	
	# --lca-ranks "species:genus:family:order:class:phylum:superphylum:subkingdom:kingdom:superkingdom"
	my @all_taxonomic_labels = split(/\:/, $linage_info_lc);
	my @all_taxonomic_labels_phylum_or_more = @all_taxonomic_labels[5..8];
	
	my $superkingdom = pop(@all_taxonomic_labels);
	my $euk_pyhlum_or_more = "NA";
	
	if ($superkingdom eq "eukaryota")
	{
		foreach my $tax_label (reverse(@all_taxonomic_labels_phylum_or_more))
		{
			$euk_pyhlum_or_more = $tax_label;
			if ($tax_label ne "unknown")
			{
				last;
			}
		}
	}
	
	print $out "$superkingdom\t$euk_pyhlum_or_more\t$num_preds\n";
	
	$line = <$in>;
}
close ($out);
close ($in);